//******************************************************************************
// Copyright (c) 2013 ClutchPlay Games, LLC. All rights reserved.
//******************************************************************************

KE_PREFIX

#ifdef KE_TEX
//uniform sampler2D tex1;
uniform KE_LOWP sampler2D bgl_RenderedTexture;
varying vec2 texCoordOut;
uniform KE_LOWP float factor;
#endif // KE_TEX

//varying vec4 colorOut;

void main()
{
	KE_LOWP vec4 color = texture2D(bgl_RenderedTexture, texCoordOut);
	
	int i, j;
	vec4 sum = vec4(0);
	for (i = -2; i <= 2; i++)
	{
		for (j = -2; j <= 2; j++)
		{
			vec2 offset = vec2(i,j) * 0.01;
			offset *= factor;
			sum += texture2D(bgl_RenderedTexture, texCoordOut + offset);
		}
	}
	
//	color.r = 1.0;
//	gl_FragColor = color;
	
	// neg-bloom
 	gl_FragColor = (sum / 25.0) - (color * factor * 0.1);
	
	// bloom
// 	gl_FragColor = (sum / 25.0) + (color * factor * 0.4);
//	gl_FragColor = texture2D(bgl_RenderedTexture, gl_TexCoord[0]).rgba;

	//gl_FragColor = texture2D(bgl_RenderedTexture, texCoordOut).rgba * vec4(1.0, 1.0 - factor, 1.0 - factor, 1.0);
}