//******************************************************************************
// Copyright (c) 2013 ClutchPlay Games, LLC. All rights reserved.
//******************************************************************************

KE_PREFIX

#ifdef KE_TEX
uniform float inv_desaturate;
uniform KE_LOWP sampler2D tex1;
varying vec2 texCoordOut;
#endif // KE_TEX

varying KE_LOWP vec4 colorOut;

void main()
{
#ifdef KE_TEX
	gl_FragColor = texture2D(tex1, texCoordOut).rgba * colorOut;
	float intensity = (gl_FragColor.r * 0.3) + (gl_FragColor.g * 0.59) + (gl_FragColor.b * 0.11);
	vec4 greyscale = vec4(intensity, intensity, intensity, gl_FragColor.a);
	gl_FragColor = mix(greyscale, gl_FragColor, inv_desaturate);
#else
    gl_FragColor = vec4(1, 0, 0, 1);
#endif // KE_TEX
}