//******************************************************************************
// Copyright (c) 2013 ClutchPlay Games, LLC. All rights reserved.
//******************************************************************************

KE_PREFIX

#ifdef KE_TEX
uniform float inv_desaturate;
uniform KE_LOWP sampler2D tex1;
varying vec2 texCoordOut;
#endif // KE_TEX

varying KE_LOWP vec4 colorOut;
uniform float iGlobalTime;
uniform vec3 iResolution;
uniform float factor;

//void main()
//{
//#ifdef KE_TEX
//	gl_FragColor = texture2D(tex1, texCoordOut).rgba * colorOut;
//	float intensity = (gl_FragColor.r * 0.3) + (gl_FragColor.g * 0.59) + (gl_FragColor.b * 0.11);
//	vec4 greyscale = vec4(intensity, intensity, intensity, gl_FragColor.a);
//	gl_FragColor = mix(greyscale, gl_FragColor, inv_desaturate);
//#else
//    gl_FragColor = vec4(1, 0, 0, 1);
//#endif // KE_TEX
//}


float rand(vec2 n) {
	return fract(sin(dot(n, vec2(12.9898, 4.1414))) * 43758.5453);
}

float noise(vec2 n) {
	const vec2 d = vec2(0.0, 1.0);
	vec2 b = floor(n), f = smoothstep(vec2(0.0), vec2(1.0), fract(n));
	return mix(mix(rand(b), rand(b + d.yx), f.x), mix(rand(b + d.xy), rand(b + d.yy), f.x), f.y);
}

float fbm(vec2 n) {
	float total = 0.0, amplitude = 1.0;
	for (int i = 0; i < 7; i++) {
		total += noise(n) * amplitude;
		n += n;
		amplitude *= 0.5;
	}
	return total;
}

void main() {
	const vec3 c1 = vec3(0.1, 0.1, 0.1);
	const vec3 c2 = vec3(0.7, 0.7, 0.7);
	const vec3 c3 = vec3(0.2, 0.2, 0.2);
	const vec3 c4 = vec3(1.0, 0.9, 0.9);
	const vec3 c5 = vec3(0.1);
	const vec3 c6 = vec3(0.9);
	vec2 p = gl_FragCoord.xy * 8.0 / iResolution.xx;
	float q = fbm(p - iGlobalTime * 0.1);
	vec2 r = vec2(fbm(p + q + iGlobalTime * 0.7 - p.x - p.y), fbm(p + q - iGlobalTime * 0.4));
	vec3 c = mix(c1, c2, fbm(p + r)) + mix(c3, c4, r.x) - mix(c5, c6, r.y);
	vec4 firePx = vec4(c * cos(1.57 * gl_FragCoord.y / iResolution.y), 1.0);
	gl_FragColor = mix(texture2D(tex1, texCoordOut).rgba * colorOut, firePx, factor * 0.3);
}
