//******************************************************************************
// Copyright (c) 2013 ClutchPlay Games, LLC. All rights reserved.
//******************************************************************************

KE_PREFIX

#ifdef KE_TEX
uniform KE_LOWP sampler2D tex1;
uniform KE_LOWP float shadowAlpha;
varying vec2 texCoordOut;
#endif // KE_TEX

varying KE_LOWP vec4 colorOut;

void main()
{
#ifdef KE_TEX
#ifdef KE_TEX_RGBA
	gl_FragColor = texture2D(tex1, texCoordOut).rgba * colorOut;
#else
    float texAlpha = texture2D(tex1, texCoordOut).w;
    gl_FragColor = vec4(colorOut.r, colorOut.g, colorOut.b,
                        colorOut.a * texAlpha);
#endif // KE_TEX_RGBA
#else
    gl_FragColor = vec4(colorOut.r, colorOut.g, colorOut.b, colorOut.a);
#endif // KE_TEX
}