//******************************************************************************
// Copyright (c) 2013 ClutchPlay Games, LLC. All rights reserved.
//******************************************************************************

KE_PREFIX

attribute vec4 positionIn;
#ifdef KE_TEX
attribute vec2 texCoordIn;
#endif // KE_TEX
#ifdef KE_COLOR
attribute KE_MEDP vec4 colorIn;
#endif // KE_COLOR

uniform KE_LOWP vec4 globalColor;
uniform mat4 modelView;
uniform mat4 projection;

#ifdef KE_TEX
varying vec2 texCoordOut;
#endif // KE_TEX
varying KE_LOWP vec4 colorOut;

void main()
{
    vec4 p = modelView * positionIn;
    gl_Position = projection * p;
#ifdef KE_TEX
    texCoordOut = texCoordIn;
#endif // KE_TEX
    
#ifdef KE_COLOR
	colorOut = (colorIn / 255.0) * globalColor;
#else
    colorOut = globalColor;
#endif // KE_COLOR
}